<?php
/////////////////////////payment///////////////////////////////////
add_action('woocommerce_order_status_changed', 'wra_mysite_woocommerce_payment_complete', 99, 3);
function wra_mysite_woocommerce_payment_complete($order_id, $old_status, $new_status)
{
	$send_factor = get_option('wra_send_factor');
	if (($new_status == 'processing' || $new_status == 'on-hold' || $new_status == 'completed') && $send_factor) {
		$order = wc_get_order($order_id);

		$order_id = $order->get_id();
		$items = $order->get_items();
		$order_data = $order->get_data();
		$user_id = $order->get_user_id();
		$user = $order->get_user();


		$order_items = [];

		$ItemsSumPrice = 0;
		$TotalPrice = 0;
		$DiscountPrice = 0;
		$TaxPrice = 0;
		$TollPrice = 0;
		$RowDiscountSumPrice = 0;



		$itemsCount = 0;
		if ($items)
			foreach ($items as $item) {

				$product = wc_get_product($item['product_id']);

				$total_price = $product->get_regular_price() * $item['quantity'];
				$final_price = $product->get_sale_price() * $item['quantity'];
				if(!$final_price)$final_price=$total_price;
				$TotalPrice += $total_price;
				$DiscountPrice += 0;
				$TaxPrice += $item['total_tax'];
				$TollPrice += 0;
				$RowDiscountSumPrice += $total_price - $final_price;
				//ItemsSumPrice = F_Sum_FCI_TotalPrice + F_SumTax + F_SumToll - F_Discount - F_SumRowDiscount
				$ItemsSumPrice += $total_price + $item['total_tax'] - $DiscountPrice - ($total_price - $final_price);
				//echo $total_price .'-'. $item['total_tax'] .'-'. $DiscountPrice .'-'. $RowDiscountSumPrice.'=';
				global $wpdb;
				$query = "SELECT * FROM {$wpdb->base_prefix}wra_products_map where productId=" . $item['product_id'];
				$result = $wpdb->get_results($query);

				$product_id = 0;
				$ProductCnuId = 0;

				if ($result) {
					$product_id = intval($result[0]->apiProductId);
					$ProductCnuId = intval($result[0]->ProductCnuId);
				}
				$itemsCount += $item['quantity'];
				$order_items[] = [
					"ProductId" => $product_id,
					"ProductCnuId" => $ProductCnuId,
					"Count" =>  intval($item['quantity']),
					"SalePrice" =>  intval($total_price),
					"Desc" => "",
					"TaxPercent" => intval(($item['total_tax'] * 100 / $final_price)*100)/100,
					"TaxPrice" =>  intval($item['total_tax']),
					"TollPercent" => 0,
					"TollPrice" => 0,
					"DiscountPrice" => intval($total_price - $final_price),
					"TotalPrice" => intval($total_price),
					"FinalPrice" => intval($final_price + $item['total_tax'])
				];

			}
			
		switch ($order->get_payment_method()) {
			case 'cod':
				$method = 'PaymentOnDelivery';
				break;
			case 'bacs':
				$method = 'OnlinePayment';
				break;
			default:
				$method = 'OnlinePayment';
		}

		$date = new jalaliDate();
		$Factor = array(
			"Factor" => array(
				"FactorNumber" => (String) $order_id,
				"RegisterFactorDate" => $date->getDate($order_data['date_created']->date('Y-m-d')),
				"RegisterFactorTime" => $order_data['date_created']->date('H:i:s'),
				"ItemsCount" => $itemsCount,
				"ItemsSumPrice" => $ItemsSumPrice,
				"Desc" => $order->get_customer_note(),
				"TotalPrice" => $TotalPrice,
				"DiscountPrice" => $DiscountPrice,
				"TaxPrice" => $TaxPrice,
				"TollPrice" => $TollPrice,
				"RowDiscountSumPrice" => number_format($RowDiscountSumPrice, 1, '.', ''),
				"IsInsertPersonInfo" => get_option('wra_IsInsertPersonInfo')=='on' ? 1 : 0, 
				"IsUpdatePersonInfo" => get_option('wra_IsUpdatePersonInfo')=='on' ? 1 : 0,
			),
			"FactorItems" => $order_items,
			"Person" => [
				"Name" => $order_data['billing']['first_name'] . ' ' . $order_data['billing']['last_name'],
				"Mobile" => $order_data['billing']['phone'],
				"Address" => $order_data['billing']['address_1'] . ' ' . $order_data['billing']['address_2'],
				"PostalCode" => $order_data['billing']['postcode']
			],
			"Payment" => [
				"Method" => $method,
				"TrackingNo" => time(),
				"DueDate" => date('Y-m-d\TH:i:s')

			]
		);
		//if($order_items)
		$result = wra_send_factor($order_id, $Factor);
	}
}

add_action('woocommerce_checkout_process', 'wra_phoneValidateCheckoutFields');

function wra_phoneValidateCheckoutFields()
{


	$billing_postcode = filter_input(INPUT_POST, 'billing_postcode');

	if (strlen($billing_postcode) != 10) {
		wc_add_notice(__('کد پستی باید 10 رقم باشد.'), 'error');
	}


	// $billing_phone = filter_input(INPUT_POST, 'billing_phone');

	// if (strlen(trim(preg_replace('/^[6789]\d{9}$/', '', $billing_phone))) > 0) {
	//     wc_add_notice(__('Invalid <strong>Phone Number</strong>, please check your input.'), 'error');
	// }
}

add_action('woocommerce_payment_complete', 'wra_so_payment_complete');
function wra_so_payment_complete($order_id)
{

	//   $order = wc_get_order( $order_id );
	//     $user = $order->get_user();
	//   $billingEmail = $order->billing_email;
	//   $products = $order->get_items();

	// foreach($products as $prod){
	//   $items[$prod['product_id']] = $prod['name'];
	// }

	// $url = 'http://requestb.in/15gbo981';
	// // post to the request somehow
	// wp_remote_post( $url, array(
	//  'method' => 'POST',
	//  'timeout' => 45,
	//  'redirection' => 5,
	//  'httpversion' => '1.0',
	//  'blocking' => true,
	//  'headers' => array(),
	//  'body' => array( 'billingemail' => $billingEmail, 'items' => $items ),
	//  'cookies' => array()
	//  )
	// );
}